/***************************************************************************
                          tdb3.c  -  3D filesystem browser
                             -------------------
    begin                : Fri Feb 23 2001
    copyright            : (C) 2001 by Leander Seige
    email                : leander@hgb-leipzig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*

Everything here is released under the GPL (http://www.gnu.org/copyleft/gpl.html) and coded by Leander Seige.
I would like to develop this program myself so if you have bugreports, additional code, bugfixes, comments,
suggestions, questions or something similar, please mail me: leander@hgb-leipzig.de .

*/

#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <string.h>
#include <syscall.h>
#include <sys/types.h>
#include <dirent.h>
#include <ctype.h>
#include <math.h>
#include <sys/stat.h>
#include <unistd.h>
#include <gdk-pixbuf.h>

/*	#define PI 3.1415926535897932384626433832795029	*/

#define PI 3.14159

unsigned char *osi,*oosi,*ssi;
unsigned long int www,hhh,p2w,p2h,cglmode;

int window;
int width=128,height=128;
long int c1,c2,c3,c4,cc,cc1,cc2,cc3,cc4;		/* wars unsigned */
unsigned int cctemp;
unsigned long int tlast,tnow,ttemp,tframe;

static GLuint CylinderObj=0;

unsigned long int DRN;
unsigned int DRNratio;
GLdouble mx,my,mz,r,u,v;

struct	tree_entry
{                                                            
		unsigned char	*value;
		unsigned char   *xval;                                       
		unsigned int	mode,regtype,rasterx,rasterz;
		GLfloat			posx,posy,posz,scalex,scaley,scalez;
		unsigned int	uniint0,uniint1,uniint2,uniint3;
		unsigned char	*uniptr;
		off_t			size;                    
		struct tree_entry *next;                                                
};

struct tree_entry *root, *help, *FMptr;
unsigned char *FCptr;

struct stat buf;
char startdir[4096];
char fullpath[4096];
char yabuf[4096];
unsigned char ch;
GLuint listName;
GLuint TDFSB_TEX_NUM;
GLuint *TDFSB_TEX_NAMES;

char *help_str,*tmpstr,*help_copy;
int cnt;
GLdouble prevlen;

const int lsuff=46;

char *xsuff[47];
unsigned int  tsuff[47];
char  *nsuff [3];

GLfloat fh,fh2,mono;

int MM1,SWX,SWY,PWX,PWY,aSWX,aSWY,aPWX,aPWY;
GLdouble centX,centY,acentX,acentY;
int TDFSB_SCALING=1,TDFSB_SHADE=1,TDFSB_FILENAMES=2,TDFSB_ICUBE=1,TDFSB_SHOW_DISPLAY=0,TDFSB_XL_DISPLAY=0,TDFSB_HAVE_MOUSE=1;
int TDFSB_SPEED_DISPLAY=0,TDFSB_SHOW_DOTFILES=0,TDFSB_SHOW_CROSSHAIR=0,TDFSB_FULLSCREEN=0,TDFSB_SHOW_HELP=0,TDFSB_GROUND_CROSS=0,TDFSB_NOTIFY,TDFSB_FPS=0,TDFSB_SHOW_FPS=0;
GLfloat TDFSB_MAXX,TDFSB_MAXZ;
GLfloat TDFSB_MINX,TDFSB_MINZ;
GLfloat TDFSB_STEPX,TDFSB_STEPZ;
GLint TDFSB_BALL_DETAIL=8,TDFSB_WAS_NOREAD=0;
GLfloat mousesense=1.5;
GLfloat mousespeed=2.0;
GLfloat headspeed=1.0;
GLdouble vposx,vposy,vposz,tposx,tposy,tposz,smoox,smooy,smooz,smoou,lastposz,lastposx,uposy;

	GLfloat mat_ambient[]     = { 0.7, 0.7, 0.7, 1.0 };
	GLfloat mat_ambient_red[] = { 1.0, 0.0, 0.0, 0.5 };
	GLfloat mat_ambient_yel[] = { 1.0, 1.0, 0.0, 0.5 };
	GLfloat mat_ambient_gry[] = { 1.0, 1.0, 1.0, 0.25 };
	
   	GLfloat mat_diffuse[]     = { 0.8, 0.8, 0.8, 1.0 };
   	GLfloat mat_diffuse_red[] = { 1.0, 0.0, 0.0, 0.5 };
   	GLfloat mat_diffuse_yel[] = { 1.0, 1.0, 0.0, 0.5 };
   	GLfloat mat_diffuse_gry[] = { 1.0, 1.0, 1.0, 0.25 };
   	
	GLfloat mat_specular[]     = { 0.9, 0.9, 0.9, 1.0 };
	GLfloat mat_specular_red[] = { 1.0, 0.0, 0.0, 0.5 };
	GLfloat mat_specular_yel[] = { 1.0, 1.0, 0.0, 0.5 };
	GLfloat mat_specular_gry[] = { 1.0, 1.0, 1.0, 0.25 };
   	
   	GLfloat mat_emission[]     = { 0.0, 0.0, 0.0, 1.0 };
   	GLfloat mat_emission_red[] = { 0.4, 0.2, 0.2, 0.5 };
   	GLfloat mat_emission_yel[] = { 0.4, 0.4, 0.2, 0.5 };
   	GLfloat mat_emission_gry[] = { 0.3, 0.3, 0.3, 0.25 };

   	GLfloat mat_shininess[] = { 50.0 };
   
GLfloat light_position[] = { 1.0, 2.0, 1.0, 0.0 };

 
DIR *mydir,*tempdir;
struct dirent *myent;

static GLfloat spin = 0.0;
static GLfloat lspin = 2.0;

static GLuint texName;


static GLfloat verTex2 []= 		{
		0.0,1.0,  0.0, 0.0, 1.0, -1.0,-1.0, 1.0,
		0.0,0.0,  0.0, 0.0, 1.0, -1.0, 1.0, 1.0,
		1.0,0.0,  0.0, 0.0, 1.0,  1.0, 1.0, 1.0,
		1.0,1.0,  0.0, 0.0, 1.0,  1.0,-1.0, 1.0,

		0.0,1.0,  0.0, 0.0,-1.0, -1.0,-1.0,-1.0,
		0.0,0.0,  0.0, 0.0,-1.0, -1.0, 1.0,-1.0,
		1.0,0.0,  0.0, 0.0,-1.0,  1.0, 1.0,-1.0,
		1.0,1.0,  0.0, 0.0,-1.0,  1.0,-1.0,-1.0,

		0.99,0.0,  1.0, 0.0, 0.0,  1.0, 1.0, 1.0,
		0.99,0.0,  1.0, 0.0, 0.0,  1.0, 1.0,-1.0,
		0.99,0.99,  1.0, 0.0, 0.0,  1.0,-1.0,-1.0,
		0.99,0.99,  1.0, 0.0, 0.0,  1.0,-1.0, 1.0,
	
		0.0,1.0, -1.0, 0.0, 0.0, -1.0,-1.0,-1.0,
		0.0,1.0, -1.0, 0.0, 0.0, -1.0,-1.0, 1.0,
		0.0,0.0, -1.0, 0.0, 0.0, -1.0, 1.0, 1.0,
		0.0,0.0, -1.0, 0.0, 0.0, -1.0, 1.0,-1.0,

		1.0,0.0,  0.0, 1.0, 0.0,  1.0, 1.0,-1.0,
		1.0,0.0,  0.0, 1.0, 0.0,  1.0, 1.0, 1.0,
		0.0,0.0,  0.0, 1.0, 0.0, -1.0, 1.0, 1.0,
		0.0,0.0,  0.0, 1.0, 0.0, -1.0, 1.0,-1.0	

	};
/*      Texture      Normals         Vertex        */

#include <tdb_gdkpb.c>
#include <tdb_dl.c>

void display(void);
void warpdisplay(void);
void keyboard (unsigned char key, int x, int y);

void init(void)
{
	GLUquadricObj *q = gluNewQuadric();
	CylinderObj = glGenLists(1);
	glNewList(CylinderObj, GL_COMPILE);
		glTranslatef(0.0, 0.0, -1.0);

	/* cylinder */
	gluQuadricNormals(q, GL_SMOOTH);
	gluQuadricTexture(q, GL_TRUE);
	gluCylinder(q, 0.6, 0.6, 2.0, 16, 1);

	/* end cap */
	glTranslatef(0.0, 0.0, 2.0);
	gluDisk(q, 0.0, 0.6, 16, 1);

	/* other end cap */
	glTranslatef(0.0, 0.0, -2.0);
	gluQuadricOrientation(q, GLU_INSIDE);
	gluDisk(q, 0.0, 0.6, 16, 1);

	glEndList();
	gluDeleteQuadric(q);


	glutWarpPointer(SWX/2,SWY/2);
	vposy=0; lastposx=lastposz=vposx=vposz=-10; smooy=tposy=0; smoox=tposx=1; smooz=tposz=1; 
	smoou=0; uposy=0;
	centX=SWX/4; centY=0;
	
	MM1=0;
	tframe=0;
	TDFSB_TEX_NUM=0; TDFSB_TEX_NAMES=NULL;
   	
	glClearColor(0.0,0.0,0.0,0.0);
	glShadeModel (GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);

	listName=glGenLists(2);

	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glInterleavedArrays(GL_T2F_N3F_V3F,0,verTex2);

	glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	glPixelStorei(GL_PACK_ALIGNMENT,1);	

	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
 	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
	glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient);
	glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_BACK, GL_SHININESS, mat_shininess);
	glMaterialfv(GL_BACK, GL_EMISSION, mat_emission);

	glLightfv(GL_LIGHT0, GL_POSITION, light_position);

	glEnable (GL_LIGHTING);		
	glEnable (GL_LIGHT0);

	mono=glutStrokeWidth(GLUT_STROKE_MONO_ROMAN,'W');

}


void reshape (int w, int h)
{
		centY=( ( ((GLdouble)h) * centY )/ ((GLdouble)SWY) );		
		centX=( ( ((GLdouble)w) * centX )/ ((GLdouble)SWX) );		
		SWX=w;SWY=h;
  	glViewport (0,0,(GLsizei)w,(GLsizei)h);	  	
  	if(TDFSB_NOTIFY) { keyboard('r',0,0); TDFSB_NOTIFY=0; }	
}



















void insert(char * value,char * xval,unsigned int mode,off_t size,unsigned int type, unsigned int uni0, unsigned int uni1, unsigned int uni2, unsigned int uni3, unsigned char * locptr, GLfloat posx, GLfloat posy, GLfloat posz, GLfloat scalex, GLfloat scaley, GLfloat scalez)
{
         unsigned char *temp; 

         temp =(unsigned char *) malloc(strlen(value)+1);
         	if (temp==NULL) { printf("low mem while inserting object!\n"); exit (1); }
         strcpy(temp,value);   
                                                                                                        
         if(root==NULL) {                                                       
                 root =(struct tree_entry * ) malloc(sizeof(struct tree_entry));
             	 	if (root==NULL) { printf("low mem while inserting object!\n"); exit (1); }
                 root->value=temp;   
                 root->xval =xval;   
                 root->mode=mode;
                 root->regtype=type;
                 root->uniint0=uni0;root->uniint1=uni1;root->uniint2=uni2;root->uniint3=uni3;
                 root->posx=posx;root->posy=posy;root->posz=posz;
                 root->scalex=scalex;root->scaley=scaley;root->scalez=scalez;
                 root->uniptr=locptr;
                 root->size=size;                                              
                 root->next=NULL;                                               
         } else {                                                                
                 help=root;                                                     
                 while(help->next)	help=help->next;                                        
                 help->next=(struct tree_entry * ) malloc(sizeof(struct tree_entry));
                 	if ((help->next)==NULL) { printf("low mem while inserting object!\n"); exit (1); }
                 (help->next)->value=temp;                                     
                 (help->next)->xval =xval;                                      
                 (help->next)->mode=mode;
                 (help->next)->regtype=type;
                 (help->next)->uniint0=uni0;(help->next)->uniint1=uni1;(help->next)->uniint2=uni2;(help->next)->uniint3=uni3;
                 (help->next)->posx=posx;(help->next)->posy=posy;(help->next)->posz=posz;
                 (help->next)->scalex=scalex;(help->next)->scaley=scaley;(help->next)->scalez=scalez;
                 (help->next)->uniptr=locptr;
                 (help->next)->size=size;                                                
                 (help->next)->next=NULL;                                                                                                                         
         }                                                                       
 }
















void leodir(void)
{
	unsigned int mode,temptype,uni0,uni1,uni2,uni3;	unsigned char *locptr,*temptr,*xval;	GLfloat	locpx,locpy,locpz,locsx,locsy,locsz,maxx,maxz,momx,momz,nextz;
	FILE *fileptr;

	printf("------------------DIRECTORY %s\n",startdir); 
	c1=0;c2=0;

	glDeleteLists(listName,2);
 	glDeleteTextures(TDFSB_TEX_NUM,TDFSB_TEX_NAMES);
	if (TDFSB_TEX_NAMES!=NULL)	free(TDFSB_TEX_NAMES);
	TDFSB_WAS_NOREAD=0; TDFSB_TEX_NUM=0;  TDFSB_TEX_NAMES=NULL; 

/* uU alten Speicher freigeben */
	if (DRN!=0)
	{
		help=root;	
		while(help) 		
		{
			FMptr=help;
			FCptr=help->value; free(FCptr);
			if (help->uniptr!=NULL) { FCptr=help->uniptr; free(FCptr); }	
			if (help->xval!=NULL) 	{ FCptr=help->xval;   free(FCptr); }	
			help=help->next;
			free(FMptr);
		}
		root=NULL;	DRN=0;		
	}
	
	mydir=opendir(startdir);
	if (mydir==NULL) { printf("Cannot open directory!\n"); exit(1); }

	do
	{	myent=readdir(mydir);
		if (myent!=0 && ( (TDFSB_SHOW_DOTFILES || myent->d_name[0]!='.') || !strcmp(myent->d_name,"..") ) )
		{	
			DRN++;temptype=0;xval=NULL;
			strcpy(fullpath,startdir);
			if (strlen(fullpath)>1) strcat(fullpath,"/");
			strcat(fullpath,myent->d_name); printf("Loading: %s ",myent->d_name);
			lstat (fullpath,&buf);
/* What ist it? */
			if (S_ISREG(buf.st_mode)!=0)		mode=0;
			else if (S_ISDIR(buf.st_mode)!=0)	mode=1;
			else if (S_ISCHR(buf.st_mode)!=0)	mode=2;
			else if (S_ISBLK(buf.st_mode)!=0)	mode=3;			
			else if (S_ISFIFO(buf.st_mode)!=0)	mode=4;						
			else if (S_ISSOCK(buf.st_mode)!=0)	mode=6;
			else if (S_ISLNK(buf.st_mode)!=0)	{	cc=readlink(fullpath, yabuf, 4095); yabuf[cc]='\0';
													xval=(unsigned char *) malloc(sizeof(char)*(strlen(yabuf)+1));
													if (xval==NULL) { printf("low mem while detecting link\n"); exit (1); }
         											strcpy(xval,yabuf); 
         
													printf("LINK: %s -> %s ",fullpath,yabuf);
													if (yabuf[0]!='/') { strcpy(fullpath,startdir); if (strlen(fullpath)>1) strcat(fullpath,"/"); strcat(fullpath,yabuf); }
													else strcpy(fullpath,yabuf);
													lstat (fullpath,&buf);
																	
													if (S_ISREG(buf.st_mode)!=0)		mode=0x20;
													else if (S_ISDIR(buf.st_mode)!=0)	mode=0x21;
													else if (S_ISCHR(buf.st_mode)!=0)	mode=0x22;
													else if (S_ISBLK(buf.st_mode)!=0)	mode=0x23;			
													else if (S_ISFIFO(buf.st_mode)!=0)	mode=0x24;						
													else if (S_ISLNK(buf.st_mode)!=0)	mode=0x25;									
													else if (S_ISSOCK(buf.st_mode)!=0)	mode=0x26;

													printf (" mode: 0x%x ",mode);
												}

/* Check Permissions */
			if ((mode&0x1F)==1)	{ if  ((access(fullpath,R_OK)<0)||(access(fullpath,X_OK)<0))	{ mode=((mode&0x1F)+10)|(mode&0x20); TDFSB_WAS_NOREAD=1;}	}
			else if (access(fullpath,R_OK)<0)												{ mode=((mode&0x1F)+10)|(mode&0x20); TDFSB_WAS_NOREAD=1;}				

/* Data File Identifizierung */
			if ((mode&0x1F)==0)	{	for (cc=1;cc<=lsuff;cc++)
								{	
									if 	( !strncmp( xsuff[cc],	&(fullpath[strlen(fullpath)-strlen(xsuff[cc])]),	strlen(xsuff[cc]) )	)
									{	temptype=tsuff[cc];	break;}
								}
							}

/* Data File Loading + Setting Parameters */
			if ((mode&0x1F)==1||(mode&0x1F)==11)
								{
									temptype=0; locpx=locpz=locpy=0; locsx=locsy=locsz=1; locptr=NULL; uni0=0; uni1=0; uni2=0;
									printf(" .. DIR done.\n");
								}
			else if (temptype==1)
								{	locptr=read_gdkpb(fullpath);
									if (!locptr)
									{	printf("IMAGE FAILED: %s\n",fullpath);
										locptr=NULL; uni0=0; uni1=0; uni2=0; uni3=0; temptype=0;
										locsy=((GLfloat)log(((double)buf.st_size/1024)+1))+1;  locsx=locsz=((GLfloat)log(((double)buf.st_size/8192)+1))+1;
										locpx=locpz=0; locpy=locsy-1;
									}
									else
									{	uni0=p2w; uni1=p2h; uni2=cglmode; uni3=0; /* width height colormode NULL */
										printf("IMAGE: %dx%d %s TEXTURE: %dx%d\n",www,hhh,fullpath,uni0,uni1);
										if (www<hhh)	{ locsx=locsz=((GLfloat)log(((double)www/512)+1))+1; locsy=(hhh*(locsx))/www; }
										else			{ locsy=((GLfloat)log(((double)hhh/512)+1))+1; locsx=locsz=(www*(locsy))/hhh; }
										locsz=1.44/(((GLfloat)log(((double)buf.st_size/1024)+1))+1);
										locpx=locpz=0; locpy=locsy-1; TDFSB_TEX_NUM++;
									}
								}
			else if (temptype==2)
								{	uni0=0; uni1=0; uni2=0; uni3=0; c1=0; c2=0; c3=0;
									fileptr=fopen(fullpath,"r");
									if(!fileptr)
									{	printf("TEXT FAILED: %s\n",fullpath); locptr=NULL; temptype=0; }
									else
									{		do 	{ c3=fgetc(fileptr); if ((c3!=EOF)&&(isgraph(c3)||c3==' ')) c1++; }	while (c3!=EOF); rewind(fileptr);
											locptr=(unsigned char *)malloc( (c1+21)*sizeof(unsigned char) ); 
											if (!locptr)
											{	printf("TEXT FAILED: %s\n",fullpath); fclose(fileptr); locptr=NULL; temptype=0; }
											else	
											{	temptr=locptr; uni0=((GLfloat)log(((double)buf.st_size/256)+1))+6;
												for (c3=0;c3<10;c3++) { *temptr=' '; temptr++; }
										 		do 	{ c3=fgetc(fileptr); if ((c3!=EOF)&&(isgraph(c3)||c3==' ')) { *temptr=(unsigned char)c3; temptr++; c2++; } }
										 		while ((c3!=EOF)&&(c2<c1));
										 		for (c3=0;c3<10;c3++) { *temptr=' '; temptr++; }
										 		*temptr=0;
										 		fclose(fileptr);
										 		printf("TEXT: %d char.\n",c1);
											}
									}
									locsy=((GLfloat)log(((double)buf.st_size/1024)+1))+1;  locsx=locsz=((GLfloat)log(((double)buf.st_size/8192)+1))+1;
									locpx=locpz=0; locpy=locsy-1;
								}
			else 				{		locptr=NULL; uni0=0; uni1=0; uni2=0; uni3=0; temptype=0;
										locsy=((GLfloat)log(((double)buf.st_size/1024)+1))+1;  locsx=locsz=((GLfloat)log(((double)buf.st_size/8192)+1))+1;
										locpx=locpz=0; locpy=locsy-1;
										printf(" .. done.\n");
								}
			
			insert(myent->d_name,xval,mode,buf.st_size,temptype,uni0,uni1,uni2,uni3,locptr,locpx,locpy,locpz,locsx,locsy,locsz);
		}
	}while (myent!=0);

	closedir(mydir);


/* Objektpositionen berechnen */
 
	DRNratio=(int) sqrt((double)DRN); help=root; cc=0; maxz=0; momx=0; momz=0; nextz=0;
	
	for(c2=0;c2<=DRNratio;c2++)
	{	momz+=maxz+nextz+2*(log(help->scalez+1))+4; maxz=0; momx=0;	
		for(c1=0;c1<=DRNratio;c1++)
		{
			if (help->scalez>maxz) { maxz=help->scalez; }
			momx=momx+(help->scalex);
			help->posx=momx; help->posz=momz; 
			help->rasterx=c1; help->rasterz=c2; 
			momx=momx+(help->scalex); 
			help=help->next;
			if (!help) break;
			momx=momx+2*(log(help->scalex+1))+4; /* Wege zw den Objekte, min 1 */
		}
		if (!help) break;
		FMptr=help; nextz=0;
		for(c1=0;c1<=DRNratio;c1++) { if(FMptr->scalez>nextz) nextz=FMptr->scalez; FMptr=FMptr->next; if(!FMptr) break; }
	}

/* Calculate Ground Grid */
	TDFSB_MAXX=TDFSB_MAXZ=0;
	help=root;	while (help)		{	if (help->posx+help->scalex>TDFSB_MAXX) TDFSB_MAXX=help->posx+help->scalex; 
										if (help->posz+help->scalez>TDFSB_MAXZ) TDFSB_MAXZ=help->posz+help->scalez;
										if (help->next) help=help->next; else help=NULL;
									}
	TDFSB_MAXX+=10;TDFSB_MAXZ+=10;
	TDFSB_MINX=root->posx-10;TDFSB_MINZ=root->posz-10;TDFSB_STEPX=(TDFSB_MAXX-TDFSB_MINX)/20;TDFSB_STEPZ=(TDFSB_MAXZ-TDFSB_MINZ)/20;
	printf("GRIDCELLSIZE: %f|%f\n",TDFSB_STEPX,TDFSB_STEPZ);

/* Reorganize Fileobject Locations : UGLY!!! ;)	*/
	help=root; while (help)			{	FMptr=help;
										do {	if (!(FMptr->next)) { break; }
												if (((FMptr->next)->rasterz)!=(help->rasterz)) {  break; }
												FMptr=FMptr->next;
										} while (TRUE);
										momx=(TDFSB_MAXX-10-(FMptr->posx+FMptr->scalex))/2;
										while (help!=FMptr) { help->posx+=momx; help=help->next; } 
										help->posx+=momx;
										if (help->next) help=help->next; else help=NULL;
									} 

/* Creating Texture Objects */
 	printf("%d Textures loaded\n",TDFSB_TEX_NUM);

	if (!(TDFSB_TEX_NAMES=(GLuint *)malloc((TDFSB_TEX_NUM+1)*sizeof(GLuint)))) { printf("low mem while alloc texture names\n"); exit(1);}
	glGenTextures(TDFSB_TEX_NUM,TDFSB_TEX_NAMES);

	c1=0;
	for (help=root;help;help=help->next)
	{
		if (((help->regtype)==1)&&(((help->mode)&0x1F)==0))
		{
			glBindTexture(GL_TEXTURE_2D, TDFSB_TEX_NAMES[c1]);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);	
			glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
			glTexImage2D(GL_TEXTURE_2D, 0, (GLenum)help->uniint2, help->uniint0, help->uniint1, 0, (GLenum)help->uniint2, GL_UNSIGNED_BYTE, help->uniptr);	

			help->uniint3=TDFSB_TEX_NAMES[c1];
			c1++;
		}
	}
	
/* Creating Display List */

	listName=glGenLists(2);
	if (!listName)	exit(1);
	tdb_gen_list();

/* Kontrolloutput */
	
	help=root;
	for(help=root;help;help=help->next) 
	{
		printf ("[%d,%d] ",help->rasterx,help->rasterz);
		printf ("%s %d  ",help->value,help->size);
		if (((help->mode)&0x1F)==1) 
		{
			printf("DIR");
		}
		else 		
		{
		 	printf ("%d-%s-FILE",help->regtype,nsuff[help->regtype]);	
		}
		printf ("\n");
	}

	vposy=0; lastposx=lastposz=vposx=vposz=-10; smooy=tposy=0; smoox=tposx=1; smooz=tposz=1; 
	smoou=0; uposy=0;
	centX=SWX/6; centY=0;

	strcpy(fullpath,"TDFSB: ");
	strcat(fullpath,startdir);
	glutSetWindowTitle(fullpath);

	printf("Display . files: "); if (TDFSB_SHOW_DOTFILES) printf ("YES.\n"); else printf ("NO.\n");

	return;	
}


















/* TDFSB IDLE FUNCTIONS contains forward() backward() upward() stillDisplay() noDisplay() */



void forward(void)
{
		vposz=vposz+tposz/mousespeed;
		vposx=vposx+tposx/mousespeed;
	glutPostRedisplay();		
		
}

void backward(void)
{
		vposz=vposz-tposz/mousespeed;
		vposx=vposx-tposx/mousespeed;
	glutPostRedisplay();
		
}

void upward(void)
{
	if (uposy!=vposy) { vposy+=(uposy-vposy)/2; }
	if (vposy<0) vposy=0;
	glutPostRedisplay();	
}

void stillDisplay(void) 
{
	
	glutPostRedisplay();
}

void nullDisplay(void) 
{
	
	glutPostRedisplay();	

}

void empty(void) 
{

}

void noDisplay(void) 
{
	char warpmess[]="WARPING...";

	glutWarpPointer(SWX/2,SWY/2);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	
	glMatrixMode(GL_PROJECTION); glLoadIdentity(); gluOrtho2D(0.0,(GLfloat)SWX,0.0,(GLfloat)SWY);
	glDisable(GL_LIGHTING);	
	glTranslatef(SWX/2-glutStrokeLength(GLUT_STROKE_ROMAN,(unsigned char *)warpmess)*0.075,SWY/2,0); glLineWidth(2);
		glColor3f(0.5,1.0,0.5);
		strcpy(fullpath, warpmess); c3=(int)strlen(fullpath);
 		glScalef(0.15,0.15,0.15);
		for (c2=0;c2<c3;c2++) { glutStrokeCharacter(GLUT_STROKE_ROMAN, fullpath[c2]); }
	glEnable(GL_LIGHTING);	
	glutSwapBuffers();	
	
	leodir();
	glutDisplayFunc(display);	
	glutIdleFunc(stillDisplay);

}















/* TDFSB DISPLAY FUNCTIONS contains display() warpdisplay() */



void display(void)
{
	if (TDFSB_HAVE_MOUSE) { glutWarpPointer(SWX/2,SWY/2); }
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	TDFSB_FPS++;
	
	glEnable(GL_LIGHTING);
	glMatrixMode(GL_MODELVIEW);
	
		glLoadIdentity();	
		light_position[0]=vposx;
		light_position[1]=vposy;
		light_position[2]=vposz;
		light_position[3]=1;
		glLightfv(GL_LIGHT0, GL_POSITION, light_position);

	glPushMatrix();	
	glCallList(listName);	
	glPopMatrix();	

	spin=(int)fmod(spin,360);spin++;
	c1=0;
	
	for(help=root;help;help=help->next) 
	{	mx=help->posx;	mz=help->posz; my=help->posy;

		if (TDFSB_GROUND_CROSS)
		{			
			glDisable (GL_LIGHTING);		
			glColor4f(0.3,0.4,0.6,1.0);
			glBegin(GL_LINES);
				glVertex3f(vposx+2,-1,vposz);		
				glVertex3f(vposx-2,-1,vposz);					
				glVertex3f(vposx  ,-1,vposz+2);					
				glVertex3f(vposx  ,-1,vposz-2);							
			glEnd();
			glEnable (GL_LIGHTING);		
		}
			
		if (TDFSB_FILENAMES)
		{	glPushMatrix();		
			if (!((help->mode)&0x20)) glTranslatef( mx,my,mz ); else glTranslatef( mx,1.5,mz );
			glDisable (GL_LIGHTING);

			if (TDFSB_FILENAMES==1) {
				glRotatef(spin+(fmod(c1,10)*36),0,1,0);
 				if (!((help->mode)&0x20)) glTranslatef(help->scalex,1.5,help->scalez); 
    			glRotatef(90-45*(help->scalez/help->scalex),0,1,0);	
    		}
			else if (TDFSB_FILENAMES==2){
				u=mx-vposx; v=mz-vposz; r=sqrt(u*u+v*v);				
				if 			(v>=0) 			 { glRotated( fmod(135+ asin(u/r)*(180/PI) ,360) ,0,1,0); }	
				else  				    	 { glRotated( fmod(315- asin(u/r)*(180/PI) ,360) ,0,1,0); }
				if (((help->mode)==0x00)&&((help->regtype)==1)) glRotatef(-45,0,1,0);		
				if (!((help->mode)&0x20)) { glTranslatef((help->scalex)+1,1.5,(help->scalez)+1);  glRotatef(90-45*(help->scalez/help->scalex),0,1,0);  }
				else  { glTranslatef(0,0.5,0); glRotatef(45,0,1,0); }						
			}
 			
 			glScalef(0.005,0.005,0.005); 

			if (!((help->mode)&0x20))
			{
				glColor4f(1.0,1.0,1.0,1.0);	
 				strcpy(fullpath,help->value);
 				c3=(int)strlen(fullpath);
 				glTranslatef(-glutStrokeLength(GLUT_STROKE_ROMAN,(unsigned char *)fullpath)/2,0,0);	
 				for (c2=0;c2<c3;c2++)	{	glutStrokeCharacter(GLUT_STROKE_ROMAN, fullpath[c2]); }
 				
    		}
    		else
    		{		fh=((((GLfloat)spin)-180)/360);
				if (fh<0) {fh=fabs(fh); strcpy(fullpath,help->value); glColor4f(1-(fh),1-(fh),1-(fh),1.0);}  else {fh=fabs(fh); strcpy(fullpath,help->xval); glColor4f(0.85-(fh),1-(fh),1-(fh),1.0);}
 				c3=(int)strlen(fullpath);
 				glTranslatef(-glutStrokeLength(GLUT_STROKE_ROMAN,(unsigned char *)fullpath)/2,0,0); 					
 				for (c2=0;c2<c3;c2++)	{	glutStrokeCharacter(GLUT_STROKE_ROMAN, fullpath[c2]); }
    		}
     		glPopMatrix();
		}
		if ( ((help->mode)==1) || (((help->mode)&0x20)&&(((help->mode)&0x1F)<10)) )
		{	
			if ( mx+(help->scalex)>vposx && mx-(help->scalex)<vposx && mz+(help->scalez)>vposz && mz-(help->scalez)<vposz && my-(help->scaley)<vposy && my+(help->scalez)>vposy &&  !((help->mode)&0x20) &&  !(strcmp(help->value,".")==0) )
			{ 			  
			  if (strcmp(help->value,"..")==0) 
			  	{	
					if (strcmp(startdir,"/")!=0)
					{	for (cc=strlen(startdir);cc>=0&&startdir[cc]!='/';cc--);
						if (cc==0)	strcpy(startdir,"/");
						else		startdir[cc]='\0';
					}							
			  	}
			  else
			  	{	if (strlen(startdir)!=1) strcat(startdir,"/");
						strcat(startdir, help->value);
						lastposx=help->posx+help->scalex+1; lastposz=help->posz+help->scalez+1; centX=SWX/4; centY=0; vposx=-10; vposz=-10;
			  	}
			  glutIdleFunc(nullDisplay); 	glutDisplayFunc(noDisplay);	
			  return;
			}
			else if ( ((help->mode)&0x20) && vposx>mx-1 && vposx<mx+1 && vposz>mz-1 && vposz<mz+1 && vposy<1.5 )
			{	strcpy (yabuf, help->xval);	strcpy(fullpath,startdir);
/*				printf("GOTO LINK: %s/%s -> %s\n",startdir,help->value,help->xval);		*/
				if (((help->mode)&0x1F)!=1) 														/* wenn !=dir filename abklemmen */
				{
					for (cc=strlen(yabuf);(cc>=0)&&((yabuf[cc])!='/');cc--); 						/* letztes / suchen */
					if (cc==0) yabuf[1]='\0'; else if (cc>0) yabuf[cc]='\0'; else yabuf[0]='\0'; 	/* ==0 "/" >0 "blah/" <0 "filname" also neuesdir==altesdir */
				}

				if (yabuf[strlen(yabuf)-1]=='/'&&strlen(yabuf)!=1) yabuf[strlen(yabuf)-1]='\0'; 	/* wenn noch ein / anhaengt, weg damit: "/usr" und "/usr/" */
				if (yabuf[0]=='/')	{ strcpy(startdir,yabuf); } 									/* absoluter pfad? */
				else																				/* relativer Pfad */
				{	FCptr=strtok(yabuf,"/");
					while (FCptr)																	/* pfadteile auswerten */
					{
						if (!strcmp(FCptr,"..")) { for (cc=strlen(startdir);(cc>=0)&&(startdir[cc])!='/';cc--); if (cc!=0) startdir[cc]='\0'; else if (cc==0) startdir[1]='\0'; }
						else if (strcmp(FCptr,".")) { if (strlen(startdir)!=1) strcat(startdir,"/"); strcat(startdir,FCptr); }
/*						printf("%s +> %s \n",FCptr,startdir);							*/
						FCptr=strtok(NULL,"/");	
					} 
				}
				if (strcmp(fullpath,startdir)&&strlen(fullpath)!=strlen(startdir)) { glutIdleFunc(nullDisplay); glutDisplayFunc(noDisplay); return; }
			}
		}		
		if ( (help->regtype==2) && ((help->mode)&0x1F)==0)
		{		
			glDisable (GL_LIGHTING);
			glPushMatrix();
			if ( ((help->mode)&0x20)) { cc=16; c1=8; glScalef(0.0625,0.125,0.0625); } else cc=c1=1;
			glScalef(0.005,0.005,0.005); glColor4f(1.0,1.0,0.0,1.0);	
			c3=(int)strlen(help->uniptr); c2=0;					
			glTranslatef((200*mx)*cc, (-100*(c1)+1500+((GLfloat)(((help->uniint2)=(help->uniint2)+(help->uniint0))))), (200*mz)*cc);
					if (TDFSB_FILENAMES==2){
				u=mx-vposx; v=mz-vposz; r=sqrt(u*u+v*v);				
				if 			(v>=0) 			 { glRotated( fmod(180+ asin(u/r)*(180/PI) ,360) ,0,1,0); }	
				else  				       { glRotated( fmod(0- asin(u/r)*(180/PI) ,360) ,0,1,0); }		
			}
			glTranslatef(+mono/2,0,0);
			do {	glTranslatef( -mono, -150, 0); glutStrokeCharacter(GLUT_STROKE_MONO_ROMAN, help->uniptr[c2+(help->uniint1)]); c2++; } 
			while (c2<c3&&c2<10);
			if (help->uniint2>=150) { (help->uniint1)=(help->uniint1)+1; if ((help->uniint1)>=c3-10) (help->uniint1)=0; (help->uniint2)=0; }
			glPopMatrix();
		}
		c1++;
	}

	glPushMatrix();	
	glCallList(listName+1);	
	glPopMatrix();	

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0.0,(GLfloat)SWX,0.0,(GLfloat)SWY);

	if(TDFSB_SHOW_CROSSHAIR)
	{
		if (SWX>SWY) fh2=SWX*0.025; else fh2=SWY*0.025; if (fh2>18) fh2=18;
		glPushMatrix();
			 glColor3f(0.4,0.8,0.6);
			 glBegin(GL_LINES);
					glVertex3f(SWX*0.50+fh2,SWY*0.50    , 1);
					glVertex3f(SWX*0.50-fh2,SWY*0.50    , 1);			
					glVertex3f(SWX*0.50    ,SWY*0.50+fh2, 1);
					glVertex3f(SWX*0.50    ,SWY*0.50-fh2, 1);			
			 glEnd();
		glPopMatrix();
	}
		
	if(TDFSB_SHOW_DISPLAY)
	{
			strcpy(fullpath, startdir); c3=(int)strlen(fullpath); cc=(GLfloat)glutStrokeLength(GLUT_STROKE_ROMAN,fullpath)*0.14;
			if (cc<(SWX/10)) cc=SWX/10;	
			glPushMatrix();

			if (TDFSB_SHOW_DISPLAY>1)
			{
				glColor4f(0.8,1.0,0.8,0.25);
				glEnable(GL_BLEND); glDepthMask(GL_FALSE); glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 	
				glBegin(GL_QUADS);
					glVertex3f (5, 45, 1); glVertex3f (cc+20+TDFSB_XL_DISPLAY, 45, 1); glVertex3f (cc+20+TDFSB_XL_DISPLAY, 5, 1); glVertex3f ( 5, 5, 1); 
				glEnd();
				if (TDFSB_SHOW_DISPLAY>2)
				{
					glColor4f(0.4,0.8,0.6,0.5);
					glBegin(GL_POLYGON);
						glVertex3f	(	25	+15*1, 		25	+15*0,		1);
						glVertex3f	(	25	+15*0.866,	25	+15*0.5,	1);
						glVertex3f	(	25	+15*0.5,	25	+15*0.866,	1);
						glVertex3f	(	25	+15*0, 		25	+15*1,		1);
						glVertex3f	(	25	-15*0.5,	25	+15*0.866,	1);
						glVertex3f	(	25	-15*0.866,	25	+15*0.5,	1);
						glVertex3f	(	25	-15*1, 		25	+15*0,		1);
						glVertex3f	(	25	-15*0.866,	25	-15*0.5,	1);
						glVertex3f	(	25	-15*0.5,	25	-15*0.866,	1);
						glVertex3f	(	25	-15*0, 		25	-15*1,		1);
						glVertex3f	(	25	+15*0.5,	25	-15*0.866,	1);
						glVertex3f	(	25	+15*0.866,	25	-15*0.5,	1);
					glEnd();
					glBegin(GL_LINES);
						glVertex3f (25, 25, 1);
						glColor4f(1.0,1.0,1.0,1.0);glVertex3f (15*tposx+25, 15*tposz+25, 1);
					glEnd();
				}
				glDepthMask(GL_TRUE);glDisable(GL_BLEND);
			}
				glTranslatef(10+TDFSB_XL_DISPLAY,18,1);
				glColor3f(0.4,0.8,0.6);
 				glScalef(0.14,0.14,1);
				for (c2=0;c2<c3;c2++) { glutStrokeCharacter(GLUT_STROKE_ROMAN, fullpath[c2]); }				
			glPopMatrix();				
		}

		 if(TDFSB_SHOW_HELP)
     {
       glPushMatrix();
       glTranslatef(10,SWY,0);	glScalef(0.09,0.09,1);	glColor3f(0.4,0.8,0.6);
				
			 prevlen=0; cnt=0; strcpy (help_copy,help_str);
     	 tmpstr = strtok(help_copy,"\n");
                      while (tmpstr != NULL) {
                              cnt++; glTranslatef(-prevlen,-14/0.09,0);
                              c3=(int)strlen(tmpstr);
                              for (c2=0;c2<c3;c2++) { glutStrokeCharacter(GLUT_STROKE_MONO_ROMAN,tmpstr[c2]); }
															prevlen=glutStrokeLength(GLUT_STROKE_MONO_ROMAN,tmpstr)+2/0.09;
                              tmpstr = strtok(NULL,"\n");
                        }
     	 glPopMatrix();
     }
		
		if(TDFSB_SPEED_DISPLAY)
		{
				glColor4f(0.8,1.0,0.8,0.25);
				glEnable(GL_BLEND); glDepthMask(GL_FALSE); glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			glBegin(GL_QUADS);
				glVertex3f(SWX-5-4*20,                50, 1); glVertex3f(SWX-5, 50, 1); glVertex3f(SWX-5,  30, 1); glVertex3f(SWX-5-4*20,        30, 1);
				glVertex3f(SWX-5-4*20,                25, 1); glVertex3f(SWX-5, 25, 1); glVertex3f(SWX-5,   5, 1); glVertex3f(SWX-5-4*20,         5, 1);
			glEnd();
			glDepthMask(GL_TRUE);glDisable(GL_BLEND);
			glColor3f(0.4,0.8,0.6);
			glBegin(GL_QUADS);
				glVertex3f(SWX-5-4*(21-mousespeed),        50, 1); glVertex3f(SWX-5, 50, 1); glVertex3f(SWX-5,  30, 1); glVertex3f(SWX-5-4*(21-mousespeed),        30, 1);
				glVertex3f(SWX-5-4*(10*headspeed), 25, 1); glVertex3f(SWX-5, 25, 1); glVertex3f(SWX-5,   5, 1); glVertex3f(SWX-5-4*(10*headspeed),  5, 1);
			glEnd();
				glTranslatef(SWX-95-(GLfloat)glutStrokeLength(GLUT_STROKE_ROMAN,"W")*0.14,32,0); glScalef(0.14,0.14,1); glutStrokeCharacter(GLUT_STROKE_ROMAN, 'W');
				glTranslatef(-(GLfloat)glutStrokeLength(GLUT_STROKE_ROMAN,"H"), -25*(1/0.14),0);  glutStrokeCharacter(GLUT_STROKE_ROMAN, 'H');
			TDFSB_SPEED_DISPLAY--;
		}

		glLoadIdentity();
		gluPerspective(60,(GLfloat)SWX/(GLfloat)SWY,0.5,160);
		smoox+=(tposx-smoox)/2;
		smooy+=(tposy-smooy)/2;
		smooz+=(tposz-smooz)/2;	
		
		gluLookAt(vposx,vposy,vposz,vposx+smoox,vposy+smooy,vposz+smooz,0.0,1.0,0.0);

	glutSwapBuffers();

}





void MouseMove( int x, int y )
{	
	centX=centX-(headspeed*(floor(((double)SWX)/2)-(double)x));
	centY=centY-(headspeed*(floor(((double)SWY)/2)-(double)y));
	if (centY>=SWY/2) centY=SWY/2; if (centY<=-SWY/2) centY=-SWY/2;
	tposz=((GLdouble)sin  (( ((double)centX)/(double)(SWX/mousesense/PI) ))  )*((GLfloat)cos (( ((double)centY)/(double)(SWY/PI) ))  );
	tposx=((GLdouble)cos  (( ((double)centX)/(double)(SWX/mousesense/PI) ))  )*((GLfloat)cos (( ((double)centY)/(double)(SWY/PI) ))  );
	tposy=-((GLdouble)sin (( ((double)centY)/(double)(SWY/PI) ))  );
}

void MouseLift( int x, int y )
{
	uposy+=(  (GLfloat) ( (GLfloat)(SWY/2)-(GLfloat)y )   /  25);
}

void mouse (int button, int state, int x, int y)
{
	switch (button) {

		case GLUT_LEFT_BUTTON:
			if (state == GLUT_DOWN)
				glutIdleFunc(forward);		
			else
				glutIdleFunc(stillDisplay);	
			break;

		case GLUT_RIGHT_BUTTON:
			if (state == GLUT_DOWN)
				glutIdleFunc(backward);
			else
				glutIdleFunc(stillDisplay);
			break;

		case GLUT_MIDDLE_BUTTON:
			if (state == GLUT_DOWN)
				{ glutMotionFunc(MouseLift); glutIdleFunc(upward); }
			else
				{ glutMotionFunc(MouseMove); glutIdleFunc(stillDisplay); uposy=vposy; }
			break;

		default:
			break;
	}

}

void speckey( int key, int x, int y)
{
	switch (key)
		{
		case GLUT_KEY_F1:
			if (mousespeed>1) mousespeed=mousespeed-1;
			TDFSB_SPEED_DISPLAY=100; break;
		case GLUT_KEY_F2:
			if (mousespeed<20)mousespeed=mousespeed+1;
			TDFSB_SPEED_DISPLAY=100; break;

		case GLUT_KEY_F4:
			headspeed=headspeed-.1;
			if (headspeed<0.1) headspeed=0.1;
			TDFSB_SPEED_DISPLAY=100; break;
		case GLUT_KEY_F3:
			headspeed=headspeed+.1;
			if (headspeed>2.0) headspeed=2.0;
			TDFSB_SPEED_DISPLAY=100; break;	
		
		default:
			break;
		}
}

void timer(int no)
{
	if(TDFSB_SHOW_FPS)
	{
		printf("FPS: %d  \n",TDFSB_FPS/3);
		glutTimerFunc(3000,timer,0);
	}		
	TDFSB_FPS=0;
}

void keyboard (unsigned char key, int x, int y)
{	
	switch (key) {

	 	case 27:
			printf("\nBye bye...\n\n");
			exit(0);
			break;
		
		case 'h':
			TDFSB_SHOW_HELP = 1-TDFSB_SHOW_HELP;
      break;

		case 's':
			if (TDFSB_SCALING==1) { glDisable(GL_NORMALIZE); TDFSB_SCALING=0;  }
			else { glEnable(GL_NORMALIZE); TDFSB_SCALING=1;	}
			glutIdleFunc(nullDisplay); 	glutDisplayFunc(noDisplay);
			break;
		
		case 'f':
			if (TDFSB_FULLSCREEN)
			{	
				if (TDFSB_HAVE_MOUSE) { keyboard('r',0,0); TDFSB_NOTIFY=1; }
				glutReshapeWindow(aSWX,aSWY);							
				glutPositionWindow(aPWX,aPWY);														
			}
			else
			{			
				if (TDFSB_HAVE_MOUSE) { keyboard('r',0,0); TDFSB_NOTIFY=1;	}
				aSWX=SWX;aSWY=SWY;	aPWX=glutGet(GLUT_WINDOW_X);aPWY=glutGet(GLUT_WINDOW_Y);				
				glutFullScreen();			  			
			}
			TDFSB_FULLSCREEN=1-TDFSB_FULLSCREEN;			
			break;

		case '.':
			TDFSB_SHOW_DOTFILES = 1 - TDFSB_SHOW_DOTFILES;
			glutIdleFunc(nullDisplay);
			glutDisplayFunc(noDisplay);
			break;

		case 'r':
			if (TDFSB_HAVE_MOUSE) 
			{
			TDFSB_HAVE_MOUSE=0;	glutMouseFunc(NULL);	glutMotionFunc(NULL);		glutPassiveMotionFunc(NULL);		glutSetCursor(GLUT_CURSOR_INHERIT);	    
			}
			else
			{	glutWarpPointer(SWX/2,SWY/2); smoox=tposx; smooy=tposy; smooz=tposz; 
			TDFSB_HAVE_MOUSE=1;	glutMouseFunc(mouse);	glutMotionFunc(MouseMove);	glutPassiveMotionFunc(MouseMove);	glutSetCursor(GLUT_CURSOR_NONE);	
			}
			break;
			
		case 'l':
			glutIdleFunc(nullDisplay); 	glutDisplayFunc(noDisplay);	
			break;

		case 'u':
			if (strcmp(startdir,"/")!=0)
					{	for (cc=strlen(startdir);cc>=0&&startdir[cc]!='/';cc--);
						if (cc==0)	strcpy(startdir,"/");
						else		startdir[cc]='\0';
					}
			glutIdleFunc(nullDisplay); 	glutDisplayFunc(noDisplay);
			break;

		case 'c':
			vposy=0; lastposx=lastposz=vposx=vposz=-10; smooy=tposy=0; smoox=tposx=1; smooz=tposz=1; 
			smoou=0; uposy=0;
			centX=SWX/6; centY=0;
			break;

		case 'q':
			if (TDFSB_ICUBE==1) { TDFSB_ICUBE=0;  }
			else { TDFSB_ICUBE=1;	}
			glutIdleFunc(nullDisplay); 	glutDisplayFunc(noDisplay);
			break;
			
		case 'i':
			printf("\nGL_RENDERER   = %s\n", (char *) glGetString(GL_RENDERER));
      printf("GL_VERSION    = %s\n", (char *) glGetString(GL_VERSION));
      printf("GL_VENDOR     = %s\n", (char *) glGetString(GL_VENDOR));
      printf("GL_EXTENSIONS = %s\n\n", (char *) glGetString(GL_EXTENSIONS));
      break;

		case 'd':
			if 		(TDFSB_SHOW_DISPLAY==1)	{ TDFSB_SHOW_DISPLAY=2; TDFSB_XL_DISPLAY=0;		TDFSB_SPEED_DISPLAY=200;	break;  }
			else if (TDFSB_SHOW_DISPLAY==2) { TDFSB_SHOW_DISPLAY=3; TDFSB_XL_DISPLAY=45;	TDFSB_SPEED_DISPLAY=200;	break;	}
			else if (TDFSB_SHOW_DISPLAY==3) { TDFSB_SHOW_DISPLAY=0; TDFSB_XL_DISPLAY=0;		break;	}
			else							{ TDFSB_SHOW_DISPLAY=1; TDFSB_XL_DISPLAY=0;		TDFSB_SPEED_DISPLAY=200;	break;	}

		case 'D':
			TDFSB_SHOW_CROSSHAIR = 1 - TDFSB_SHOW_CROSSHAIR;
			break;
		
		case 'F':
			if (!TDFSB_SHOW_FPS)	{	glutTimerFunc(3000,timer,0); TDFSB_FPS=0; }
			TDFSB_SHOW_FPS = 1 - TDFSB_SHOW_FPS;
			break;
		case 'g':
			TDFSB_GROUND_CROSS = 1 - TDFSB_GROUND_CROSS;
			break;
			
		case 'b':
			if ( TDFSB_BALL_DETAIL>4) { TDFSB_BALL_DETAIL--;  }
			printf("New Ball Detail: %d\n",TDFSB_BALL_DETAIL);
			break;

		case 'm':
			if ( TDFSB_SHADE==1) 
			{ glShadeModel(GL_FLAT); TDFSB_SHADE=0;  }
			else
			{ glShadeModel(GL_SMOOTH); TDFSB_SHADE=1;  }
			break;

		case 't':
				TDFSB_FILENAMES++;
				if (TDFSB_FILENAMES==3)	TDFSB_FILENAMES=0;
			break;

		case 'B':
			TDFSB_BALL_DETAIL++;
			printf("New Ball Detail: %d\n",TDFSB_BALL_DETAIL);
			break;

		default:
			break;				
    }
}

int main (int argc, char** argv)
{	
	set_filetypes();
	setup_help(); 		
	
	if (getcwd(startdir, 4096) == NULL ) strcpy(startdir,"/");

	if ((argc==2)&&( !strcmp(argv[1],"--version") || !strcmp(argv[1],"-V") )) {	printf ("TDFSB 0.0.3\n"); exit(0);	}
	else if (argc==3)	{	SWX=atoi(argv[1]); SWY=atoi(argv[2]); PWX=0; PWY=0;	}
	else if (argc==5)	{	SWX=atoi(argv[1]); SWY=atoi(argv[2]); PWX=atoi(argv[3]); PWY=atoi(argv[4]);	}
	else				{	SWX=400;SWY=300;PWX=120;PWY=90;}

	if (PWX<0) PWX=0;
	if (PWY<0) PWY=0;
	if (SWX<50) SWX=50;
	if (SWY<50) SWY=50;

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowSize(SWX,SWY);
	glutInitWindowPosition(PWX,PWY);
	window=glutCreateWindow(argv[0]);	

	init();
	glutIdleFunc(stillDisplay);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);
	glutMotionFunc(MouseMove);	
	glutSpecialFunc(speckey);
	glutPassiveMotionFunc(MouseMove);	
	glutSetCursor(GLUT_CURSOR_NONE);	
	glutKeyboardFunc(keyboard);

	leodir();
	
	glutMainLoop();

	return 0;
}
