/***************************************************************************
                          tdb_dl.c  -  3D filesystem browser
                             -------------------
    begin                : Fri Feb 23 2001
    copyright            : (C) 2001 by Leander Seige
    email                : leander@hgb-leipzig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
Everything here is released under the GPL (http://www.gnu.org/copyleft/gpl.html) and coded by Leander Seige.
I would like to develop this program myself so if you have bugreports, additional code, bugfixes,
suggestions, questions or something similar, please mail me: leander@hgb-leipzig.de .
*/

void tdb_gen_list(void)
{

/*  */
/* Main Display List */
/*  */

	glNewList(listName,GL_COMPILE);
/* drawing the objects aka files */
		for(help=root;help;help=help->next) 
		{
			glPushMatrix();
			mx=help->posx;	mz=help->posz; my=help->posy;
			glTranslatef( mx, my, mz );
			
			if ( ((help->mode)&0x1F) == 1 || ((help->mode)&0x1F) == 11) 
			{	
				if ((help->mode)&0x20) glutSolidSphere(0.5,TDFSB_BALL_DETAIL,TDFSB_BALL_DETAIL);
				else glutSolidSphere(1,TDFSB_BALL_DETAIL,TDFSB_BALL_DETAIL);

			}
			else if ( ((help->mode)&0x1F) == 0 || ((help->mode)&0x1F) == 10) 	
			{
				if ( (help->regtype==1) && ((help->mode)&0x1F)==0)
				{		
					if (TDFSB_SCALING)	{	if ((help->mode)&0x20) { glTranslatef(0,-my,0);
														if (help->scalex > help->scaley) {
															if (help->scalex > help->scalez) 
															glScalef(0.5,0.5*(help->scaley)/(help->scalex),0.5*(help->scalez)/(help->scalex)); /* x am groessten */
															else 
															glScalef(0.5*(help->scalex)/(help->scalez),0.5*(help->scaley)/(help->scalez),0.5);  /* z am groessten */
														}
														else if (help->scaley > help->scalez)
															glScalef(0.5*(help->scalex)/(help->scaley),0.5,0.5*(help->scalez)/(help->scaley));  /* y am groessten */
														else
															glScalef(0.5*(help->scalex)/(help->scalez),0.5*(help->scaley)/(help->scalez),0.5);  /* z am groessten */
											}
											else  glScalef(help->scalex,help->scaley,help->scalez);  
										}
					glEnable(GL_TEXTURE_2D); glBindTexture(GL_TEXTURE_2D,help->uniint3);
					if (TDFSB_ICUBE)	glDrawArrays(GL_QUADS, 0, 20); else  glDrawArrays(GL_QUADS, 0, 4); 			
					glDisable(GL_TEXTURE_2D);
				}
				else if (help->regtype!=2)	
				{ 
						if (TDFSB_SCALING)	{ 	if ((help->mode)&0x20) { glTranslatef(0,-my,0);
														if (help->scalex > help->scaley) {
															if (help->scalex > help->scalez) 
															glScalef(0.5,0.5*(help->scaley)/(help->scalex),0.5*(help->scalez)/(help->scalex)); /* x am groessten */
															else 
															glScalef(0.5*(help->scalex)/(help->scalez),0.5*(help->scaley)/(help->scalez),0.5);  /* z am groessten */
														}
														else if (help->scaley > help->scalez)
															glScalef(0.5*(help->scalex)/(help->scaley),0.5,0.5*(help->scalez)/(help->scaley));  /* y am groessten */
														else
															glScalef(0.5*(help->scalex)/(help->scalez),0.5*(help->scaley)/(help->scalez),0.5);  /* z am groessten */
											}
												else glScalef(help->scalex, help->scaley, help->scalez);
											}
						glutSolidCube(2);
				}
			}
			else
			{
				if ((help->mode)!=0x25)
				{	
					if (((help->mode)&0x20))	glScalef(0.5,0.5,0.5);
					glutSolidOctahedron();		
				}
			}
			glPopMatrix();
		}
/* drawing the ground grid */
		glPushMatrix();	
		glDisable (GL_LIGHTING);		
		glColor4f(0.2,0.2,0.6,1.0);
	
		for (c1=0;c1<=20;c1++)
		{
			glBegin(GL_LINES);
				glVertex3f (	TDFSB_MINX+TDFSB_STEPX*c1,	-1,	TDFSB_MINZ);
				glVertex3f (	TDFSB_MINX+TDFSB_STEPX*c1,	-1,	TDFSB_MAXZ);
				glVertex3f (	TDFSB_MINX,					-1,	TDFSB_MINZ+TDFSB_STEPZ*c1);
				glVertex3f (	TDFSB_MAXX,					-1,	TDFSB_MINZ+TDFSB_STEPZ*c1);
			glEnd();
		}

		glEnable (GL_LIGHTING);	
		glPopMatrix();	
	glEndList();

/*  */
/* Display List Transparente Objekte 	*/
/*  */

	glNewList(listName+1,GL_COMPILE);
		glEnable (GL_LIGHTING);	
		glEnable(GL_BLEND); glDepthMask(GL_FALSE); glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 	
		for(help=root;help;help=help->next) 
		{	mx=help->posx;	mz=help->posz; my=help->posy;
			if (( (help->regtype==2) && ((help->mode)&0x1F)==0))
			{	
				glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse_yel);glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient_yel);glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular_yel);glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission_yel);
    			glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse_yel);glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient_yel);glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular_yel);glMaterialfv(GL_BACK, GL_EMISSION, mat_emission_yel);
					glPushMatrix(); if ( ((help->mode)&0x20)) { glTranslatef(mx,0,mz); glScalef(0.25,0.55,0.25);glColor3f(0.8, 0.8, 0); glRotatef(90,1,0,0); }
									else { glTranslatef(mx,3.5,mz); glScalef(help->scalex, 4.5, help->scalez); glColor3f(0.8, 0.8, 0); glRotatef(90,1,0,0); }
						glCallList(CylinderObj);
					glPopMatrix();
			}
			if ( ((help->mode)&0x1F) >= 10) 
			{
				glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse_red);glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient_red);glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular_red);glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission_red);
    			glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse_red);glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient_red);glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular_red);glMaterialfv(GL_BACK, GL_EMISSION, mat_emission_red);
			 		glPushMatrix(); glTranslatef(help->posx, help->posy+.25, help->posz); /* if (((help->mode)&0x20)) glScalef(1.2, 1.2, 1.2); */
			 		glScalef((help->scalex)+.25,(help->scaley)+.25,(help->scalez)+.25); glutSolidCube(2); glPopMatrix();
			}
			if ( ((help->mode)&0x20)) 
			{
				glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse_gry);glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient_gry);glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular_gry);glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission_gry);
    			glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse_gry);glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient_gry);glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular_gry);glMaterialfv(GL_BACK, GL_EMISSION, mat_emission_gry);
			 		glPushMatrix(); glTranslatef(mx, 0, mz); if ((help->mode)==0x25) glutSolidSphere(0.5,TDFSB_BALL_DETAIL,TDFSB_BALL_DETAIL); glutSolidSphere(1,TDFSB_BALL_DETAIL,TDFSB_BALL_DETAIL); glPopMatrix();
			}				
		}
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
	glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse);glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient);glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular);glMaterialfv(GL_BACK, GL_EMISSION, mat_emission);
	glDepthMask(GL_TRUE);glDisable(GL_BLEND);
	glDisable(GL_LIGHTING);
	glEndList();
}


void set_filetypes(void)
{
	xsuff[ 0]="ERRR";					tsuff[ 0]=0;
	xsuff[ 1]=".jpeg";				tsuff[ 1]=1;
	xsuff[ 2]=".JPEG";				tsuff[ 2]=1;
	xsuff[ 3]=".jpg";					tsuff[ 3]=1;
	xsuff[ 4]=".JPG";					tsuff[ 4]=1;
	xsuff[ 5]=".jpe";					tsuff[ 5]=1;
	xsuff[ 6]=".JPE";					tsuff[ 6]=1;
	xsuff[ 7]=".gif";					tsuff[ 7]=1;
	xsuff[ 8]=".GIF";					tsuff[ 8]=1;
	xsuff[ 9]=".tif";					tsuff[ 9]=1;
	xsuff[10]=".TIF";					tsuff[10]=1;
	xsuff[11]=".tiff";				tsuff[11]=1;
	xsuff[12]=".TIFF";				tsuff[12]=1;
	xsuff[13]=".png";					tsuff[13]=1;
	xsuff[14]=".PNG";					tsuff[14]=1;
	xsuff[15]=".bmp";					tsuff[15]=1;	/* .pnm */
	xsuff[16]=".BMP";					tsuff[16]=1;	/* .PNM */
	xsuff[17]=".ras";					tsuff[17]=1;
	xsuff[18]=".RAS";					tsuff[18]=1;
	xsuff[19]=".ico";					tsuff[19]=1;
	xsuff[20]=".ICO";					tsuff[20]=1;
	xsuff[21]=".bmp";					tsuff[21]=1;
	xsuff[22]=".BMP";					tsuff[22]=1;
	xsuff[23]=".txt";					tsuff[23]=2;
	xsuff[24]=".TXT";					tsuff[24]=2;
	xsuff[25]=".c";						tsuff[25]=2;
	xsuff[26]=".C";						tsuff[26]=2;
	xsuff[27]=".h";						tsuff[27]=2;
	xsuff[28]=".htm";					tsuff[28]=2;
	xsuff[29]=".html";				tsuff[29]=2;
	xsuff[30]=".HTM";					tsuff[30]=2;
	xsuff[31]=".HTML";				tsuff[31]=2;	
	xsuff[32]=".pl";					tsuff[32]=2;	
	xsuff[33]="README";				tsuff[33]=2;	
	xsuff[34]="LICENSE";			tsuff[34]=2;
	xsuff[35]="LICENSE-GPL";	tsuff[35]=2;		
	xsuff[36]="LICENSE-LGPL";	tsuff[36]=2;
	xsuff[37]=".src";					tsuff[37]=2;
	xsuff[38]=".SRC";					tsuff[38]=2;
	xsuff[39]=".asc";					tsuff[39]=2;
	xsuff[40]=".ascii";				tsuff[40]=2;
	xsuff[41]=".ASCII";				tsuff[41]=2;
	xsuff[42]=".ASC";					tsuff[42]=2;
	xsuff[43]=".sgml";				tsuff[43]=2;
	xsuff[44]=".SGML";				tsuff[44]=2;
	xsuff[45]=".java";				tsuff[45]=2;
	xsuff[46]=".JAVA";				tsuff[46]=2;

	nsuff[0]="UNKNOWN";
	nsuff[1]="PICTURE";
	nsuff[2]="TEXT";

}

void setup_help(void)	
{
        help_str  = (char*) malloc (1024*sizeof(char));
        help_copy = (char*) malloc (1024*sizeof(char));
        tmpstr = (char*) malloc (48);
        strcat (help_str,"Esc           quit   F1/F2    speed +/-\n");
        strcat (help_str,"Mouse move    look   F3/F4      rot +/-\n");
        strcat (help_str,"LMB        forward   D        crosshair\n");
        strcat (help_str,"RMB       backward   g     ground cross\n");
        strcat (help_str,"MMB        up/down   F        print FPS\n");
        strcat (help_str,"d          display   f       fullscreen\n");
        strcat (help_str,"t        filenames\n");
        strcat (help_str,"c        start pos\n");
        strcat (help_str,".          . files\n");
        strcat (help_str,"r   rel./get mouse\n");
        strcat (help_str,"l       reload dir\n");
        strcat (help_str,"u             cd..\n");
        strcat (help_str,"m          shading\n");
        strcat (help_str,"h        show help\n");
        strcat (help_str,"i    print GL info\n");
        strcat (help_str,"\n");
        strcat (help_str,"b/B   ball detail -/+\n");
        strcat (help_str,"( reload to take effect )\n");
}
